// ------------------------------------------------
// drawRot
// ------------------------------------------------
void drawRot(PGraphics g, damkjer.ocd.Camera cam)
{
  int nbSub = 20;
  float aStart = 0;
  float aEnd = TWO_PI-PI/4.0;;
  float aStep = (aEnd-aStart)/nbSub;
  float x=0,y=0,a=0;
  float r=5;
  g.pushMatrix();  
  g.beginShape(LINES);
  for (int i=0;i<=nbSub;i++)
  {
      x = r*cos(a);
      y = r*sin(a);
//      g.vertex(0);
      a+=aStep;
  }
  g.endShape();
  g.popMatrix();  
}

// ------------------------------------------------
// drawFrustum
// ------------------------------------------------
void drawFrustum(PGraphics g, damkjer.ocd.Camera cam)
{
  float zNearClip = cam.nearClip();  
  float zFarClip = cam.farClip();  
  float fov = cam.fov();
  float wn=0,hn=0,wf=0,hf=0;

  // Near  
  if (drawFrustumNear)
  {
    hn = zNearClip*tan(0.5f*fov);
    wn = aspectRatio*hn;

    g.pushMatrix();
    g.translate(0,0,-zNearClip);
    g.beginShape(QUADS);
    g.vertex(-wn,-hn,0);
    g.vertex(-wn,hn,0);
    g.vertex(wn,hn,0);
    g.vertex(wn,-hn,0);
    g.endShape();
    g.popMatrix();

    g.beginShape(LINES);
    g.vertex(0,0,0);g.vertex(-wn,-hn,-zNearClip);
    g.vertex(0,0,0);g.vertex(-wn,hn,-zNearClip);
    g.vertex(0,0,0);g.vertex(wn,hn,-zNearClip);
    g.vertex(0,0,0);g.vertex(wn,-hn,-zNearClip);
    g.endShape();
  }

  // Far  
  if (drawFrustumFar)
  {
    hf = zFarClip*tan(0.5f*fov);
    wf = aspectRatio*hf;

    g.pushMatrix();
    g.translate(0,0,-zFarClip);
    g.beginShape(QUADS);
    g.vertex(-wf,-hf,0);
    g.vertex(-wf,hf,0);
    g.vertex(wf,hf,0);
    g.vertex(wf,-hf,0);
    g.endShape();
    g.popMatrix();

    g.beginShape(LINES);

    g.vertex(-wn,-hn,-zNearClip);g.vertex(-wf,-hf,-zFarClip);
    g.vertex(-wn,hn,-zNearClip);g.vertex(-wf,hf,-zFarClip);
    g.vertex(wn,hn,-zNearClip);g.vertex(wf,hf,-zFarClip);
    g.vertex(wn,-hn,-zNearClip);g.vertex(wf,-hf,-zFarClip);

    g.endShape();
  }
  
}
